package com.gic.enterprise.dto;

import lombok.Data;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

/**
 * @author guojx
 * @date 2019/7/16 4:11 PM
 */
@Data
public class EnterpriseDTO implements Serializable{
    private static final long serialVersionUID = -2344967926907229689L;

    public interface SaveEnterpriseValid {
    }

    public interface EditEnterpriseValid {
    }

    public interface BasicInfoEditValid {
    }




    /**
     * 企业主键
     */
    @NotNull(message = "主键不能改为空", groups = {EditEnterpriseValid.class})
    private Integer enterpriseId;

    /**
     * 商户名称
     */
    @NotBlank(message = "商户名称不能为空", groups = {SaveEnterpriseValid.class, BasicInfoEditValid.class})
    private String enterpriseName;

    /**
     * 公司名称
     */
    @NotBlank(message = "公司名称不能为空", groups = {SaveEnterpriseValid.class, BasicInfoEditValid.class})
    private String companyName;

    /**
     *
     */
    @NotBlank(message = "logo不能为空", groups = {SaveEnterpriseValid.class})
    private String logo;

    /**
     *
     */
    @NotBlank(message = "区号ID不能为空", groups = {SaveEnterpriseValid.class, BasicInfoEditValid.class})
    private String areaId;

    /**
     * 详细地址
     */
    @NotBlank(message = "详细地址不能为空", groups = {SaveEnterpriseValid.class, BasicInfoEditValid.class})
    private String address;

    /**
     * 状态；1有效； 0无效
     */
    private Integer status;

    /**
     *
     */
    private Date createTime;

    /**
     *
     */
    private Date updateTime;

    /**
     * 是否完成初始化
     */
    private Integer isInitComplete;

    /**
     * 基础服务过期时间
     */
    private Date auditTime;

    /**
     * 版本code
     */
    private String versionCode;

    /**
     * 版本名称
     */
    private String versionName;
    /**
     * 服务状态 0:无服务 1:正常 2:停用
     */
    private Integer serviceStatus;

    /**
     * 创建人
     */
    private Integer creatorId;

    /**
     * 前置资源，必有
     */
    private List<EnterpriseResourceRelDTO> resourcesList;
}
