package com.gic.enterprise.dto;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.Date;

/**
 *
 * @Description:
 * @author zhiwj
 * @date 2019-11-01 16:36
 */
public class InternationalSmsRecordDTO implements Serializable {

    private static final long serialVersionUID = -8620990980626601657L;

    public interface InternationalSmsRecordValid{}

    /**
     *
     */
    private Integer smsRecordId;

    /**
     *
     */
    private Integer status;

    /**
     * 发送时间
     */
    @NotNull(message = "发送时间不能为空", groups = InternationalSmsRecordValid.class)
    private Date sendTime;

    /**
     * 接收号码
     */
    @NotBlank(message = "接收号码不能为空", groups = InternationalSmsRecordValid.class)
    private String receivePhone;

    /**
     * 支付方式
     */
    private Integer payType;

    /**
     * 应用
     */
    @NotBlank(message = "应用场景不能为空", groups = InternationalSmsRecordValid.class)
    private String appCode;

    /**
     * 应用name
     */
    private String appName;

    /**
     * 短信类型
     */
    private Integer smsType;

    /**
     * 计费条数
     */
    private Integer billNumber;

    /**
     * 费用
     */
    @NotNull(message = "费用不能为空", groups = InternationalSmsRecordValid.class)
    private Double fee;

    /**
     * 短信内容
     */
    @NotBlank(message = "短信内容不能为空", groups = InternationalSmsRecordValid.class)
    private String smsContent;

    /**
     *
     */
    private Date createTime;

    /**
     *
     */
    private Date updateTime;

    /**
     * 扣费时间
     */
    private Date deductionTime;

    /**
     *
     */
    @NotNull(message = "商户id不能为空", groups = InternationalSmsRecordValid.class)
    private Integer enterpriseId;

    /**
     * 套餐包id
     */
    private Integer enterpriseSmsPackageId;

    /**
     *
     */
    @NotBlank(message = "区号不能为空", groups = InternationalSmsRecordValid.class)
    private String nationCode;

    /**
     *
     */
    @NotBlank(message = "区号不能为空", groups = InternationalSmsRecordValid.class)
    private String nationName;

    /**
     * 会员姓名
     */
    private String memberName;

    /**
     * 门店id
     */
    private Integer storeId;

    /**
     * 门店名称
     */
    private String storeName;

    /**
     * 门店分组id
     */
    private Integer storeGroupId;

    /**
     * 门店分组名称
     */
    private String storeGroupName;

    public Integer getSmsRecordId() {
        return smsRecordId;
    }

    public void setSmsRecordId(Integer smsRecordId) {
        this.smsRecordId = smsRecordId;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public Date getSendTime() {
        return sendTime;
    }

    public void setSendTime(Date sendTime) {
        this.sendTime = sendTime;
    }

    public String getReceivePhone() {
        return receivePhone;
    }

    public void setReceivePhone(String receivePhone) {
        this.receivePhone = receivePhone;
    }

    public Integer getPayType() {
        return payType;
    }

    public void setPayType(Integer payType) {
        this.payType = payType;
    }

    public String getAppCode() {
        return appCode;
    }

    public void setAppCode(String appCode) {
        this.appCode = appCode;
    }

    public String getAppName() {
        return appName;
    }

    public void setAppName(String appName) {
        this.appName = appName;
    }

    public Integer getSmsType() {
        return smsType;
    }

    public void setSmsType(Integer smsType) {
        this.smsType = smsType;
    }

    public Integer getBillNumber() {
        return billNumber;
    }

    public void setBillNumber(Integer billNumber) {
        this.billNumber = billNumber;
    }

    public Double getFee() {
        return fee;
    }

    public void setFee(Double fee) {
        this.fee = fee;
    }

    public String getSmsContent() {
        return smsContent;
    }

    public void setSmsContent(String smsContent) {
        this.smsContent = smsContent;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public Date getDeductionTime() {
        return deductionTime;
    }

    public void setDeductionTime(Date deductionTime) {
        this.deductionTime = deductionTime;
    }

    public Integer getEnterpriseId() {
        return enterpriseId;
    }

    public void setEnterpriseId(Integer enterpriseId) {
        this.enterpriseId = enterpriseId;
    }

    public Integer getEnterpriseSmsPackageId() {
        return enterpriseSmsPackageId;
    }

    public void setEnterpriseSmsPackageId(Integer enterpriseSmsPackageId) {
        this.enterpriseSmsPackageId = enterpriseSmsPackageId;
    }

    public String getNationCode() {
        return nationCode;
    }

    public void setNationCode(String nationCode) {
        this.nationCode = nationCode;
    }

    public String getNationName() {
        return nationName;
    }

    public void setNationName(String nationName) {
        this.nationName = nationName;
    }
}
