package com.gic.enterprise.dto.rule;

import lombok.Data;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.Date;

/**
 * 平台规则配置：分类
 * @ClassName: RuleClassifyDTO 
 * @Description:  
 * @author guojuxing 
 * @date 2020/3/3 2:45 PM 
 */
@Accessors(chain = true)
@Data
public class RuleClassifyDTO implements Serializable{
    private static final long serialVersionUID = 6258321185779741516L;

    /**
     *
     */
    private Integer ruleId;

    /**
     * 规则/分类/场景名称（场景名称是冗余数据）
     */
    private String ruleName;

    /**
     * 分类类型:icon
     */
    private String classifyIcon;

    /**
     * 分类/场景描述
     */
    private String ruleDesc;

    /**
     * 分类/场景备注
     */
    private String remark;

    /**
     * 父级id
     */
    private Integer parentRuleId;

    /**
     * 层级:1:规则 2:分类 3:场景
     */
    private Integer ruleLevel;

    /**
     * 规则链id：_2_3_格式数据
     */
    private String ruleChain;

    /**
     * 状态值 1:有效 0:无效
     */
    private Integer status;

    /**
     *
     */
    private Date createTime;

    /**
     *
     */
    private Date updateTime;
}
