package com.gic.enterprise.dto.rule;

import lombok.Data;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.Date;

/**
 * 平台规则配置：场景
 * @ClassName: RuleClassifySceneDTO 
 * @Description:  
 * @author guojuxing 
 * @date 2020/3/3 2:46 PM 
 */
@Accessors(chain = true)
@Data
public class RuleClassifySceneDTO implements Serializable{
    private static final long serialVersionUID = 2944424324223164756L;

    /**
     *
     */
    private Integer ruleId;

    /**
     * 规则/分类/场景名称（场景名称是冗余数据）
     */
    private String ruleName;

    /**
     * 分类/场景描述
     */
    private String ruleDesc;

    /**
     * 分类/场景备注
     */
    private String remark;

    /**
     * 营销场景ID/code
     */
    private String marketScene;

    /**
     * 营销对象 1:会员卡域 2:服务号域 3:小程序域
     */
    private Integer marketObject;

    /**
     * 父级id
     */
    private Integer parentRuleId;

    /**
     * 层级:1:规则 2:分类 3:场景
     */
    private Integer ruleLevel;

    /**
     * 规则链id：_2_3_格式数据
     */
    private String ruleChain;

    /**
     * 状态值 1:有效 0:无效
     */
    private Integer status;

    /**
     *
     */
    private Date createTime;

    /**
     *
     */
    private Date updateTime;
}
