package com.gic.enterprise.dto.rule;

import lombok.Data;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.Date;

/**
 * 平台规则配置：规则类型
 * @ClassName: RuleDTO 
 * @Description:  
 * @author guojuxing 
 * @date 2020/3/3 2:43 PM 
 */
@Accessors(chain = true)
@Data
public class RuleDTO implements Serializable{
    private static final long serialVersionUID = 5568436339396966487L;

    /**
     *
     */
    private Integer ruleId;

    /**
     * 规则/分类/场景名称（场景名称是冗余数据）
     */
    private String ruleName;

    /**
     * 规则类型:应用名称
     */
    private String appName;

    /**
     * 规则类型:应用code
     */
    private String appCode;

    /**
     * 父级id
     */
    private Integer parentRuleId;

    /**
     * 层级:1:规则 2:分类 3:场景
     */
    private Integer ruleLevel;

    /**
     * 规则链id：_2_3_格式数据
     */
    private String ruleChain;

    /**
     * 状态值 1:有效 0:无效
     */
    private Integer status;

    /**
     *
     */
    private Date createTime;

    /**
     *
     */
    private Date updateTime;
}
