package com.gic.enterprise.qo;

import lombok.Data;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.List;

/**
 * 运营商户列表查询参数
 * @ClassName: EnterpriseQO 
 * @Description:  
 * @author guojuxing 
 * @date 2020/3/12 2:56 PM 
 */
@Accessors(chain = true)
@Data
public class EnterpriseQO extends PageQO implements Serializable{
    private static final long serialVersionUID = 6358283201042863550L;

    /**
     * 公司名称/品牌名称
     */
    private String search;
    /**
     * 服务版本：例如：达摩基础版 123
     */
    private String serviceVersion;
    /**
     * 0无效，1有效，2停用，3逾期 4：即将到期
     */
    private Integer serviceStatus;
    /**
     * 用EnterpriseListOrderByEnum.getOrderBy(orderBy)解析成sql， 可以为null
     * 1:创建时间正序 2:创建时间倒叙 3:到期时间正序 4:到期时间倒叙
     * 例如：EnterpriseListOrderByEnum.getOrderBy(1)
     */
    private String orderBy;

    /**
     * 运维创建人
     */
    private Integer creatorId;

    /**
     * 运维资源组权限：1：全部商户 其他 ：部分
     */
    private Integer listAll;

    /**
     * 部分商户的时候，商户ID
     */
    private List<Integer> enterpriseIdList;
}
