package com.gic.enterprise.service;

import com.alibaba.fastjson.JSONObject;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.enterprise.dto.BillingRechargeDTO;

/**
 * 充值
 * @ClassName: BillingRechargeApiService
 * @Description:  
 * @author zhiwj
 * @date 2019/8/15 16:25
 */
public interface BillingRechargeApiService {

    /**
     * 选择支付方式，生成一个订单，如果是线上支付，会返回待扫描的二维码
     * @Title: genRechargeUrl
     * @Description: 
     * @author zhiwj
     * @param billingRechargeDTO
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Integer>
     * @throws 
     */
    ServiceResponse<JSONObject> saveAndSelectPaymentMethod(BillingRechargeDTO billingRechargeDTO);

    /**
     * 确认支付
     * @Title: confirmPay
     * @Description:
     * @author zhiwj
     * @param billingRechargeDTO
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Integer>
     * @throws
     */
    ServiceResponse<Integer> confirmPay(BillingRechargeDTO billingRechargeDTO);

    /**
     * 商户下有没有在充值的订单
     * @Title: hasRecharge
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Boolean>  true:有   false:没有
     * @throws
     */
    ServiceResponse<Boolean> hasRecharge(Integer enterpriseId);

    /**
     * @Title: updateRecharge
     * @Description:
     * @author zhiwj
     * @param billingRechargeDTO
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Integer>
     * @throws
     */
//    ServiceResponse<Integer> updateRecharge(BillingRechargeDTO billingRechargeDTO);
}
