package com.gic.enterprise.service;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.enterprise.dto.rule.RuleEnterpriseDTO;

public interface ConfigRuleEnterpriseApiService {

    /**
     * 新增商户规则
     * @Title: save 
     * @Description:
     * @author guojuxing
     * @param dto 
     * @return  com.gic.api.base.commons.ServiceResponse<java.lang.Integer> 
     */
    ServiceResponse<Integer> save(RuleEnterpriseDTO dto);

    ServiceResponse<Integer> edit(RuleEnterpriseDTO dto);

    /**
     * 删除商户规则
     * @Title: deleteEnterpriseRule 
     * @Description:
     * @author guojuxing
     * @param enterpriseRuleId 
     * @return  com.gic.api.base.commons.ServiceResponse<java.lang.String> 
     */
    ServiceResponse<String> deleteEnterpriseRule(Integer enterpriseRuleId);

    /**
     * 规则中移除商户
     * @Title: removeEnterprise 
     * @Description:
     * @author guojuxing
     * @param enterpriseId 
     * @return  com.gic.api.base.commons.ServiceResponse<java.lang.String> 
     */
    ServiceResponse<String> removeEnterprise(Integer enterpriseId);

    /**
     * 规则列表
     * @Title: listRule 
     * @Description:
     * @author guojuxing  
     * @param search 规则名称/商户名称/公司名称
     * @param pageNum
     * @param pageSize
     * @return  java.util.List<com.gic.enterprise.dto.rule.RuleEnterpriseDTO> 
     */
    ServiceResponse<Page<RuleEnterpriseDTO>> listRule(String search, Integer pageNum, Integer pageSize);

    /**
     * 商户列表
     * @Title: listEnterpriseRule 
     * @Description:
     * @author guojuxing  
     * @param search 商户名称/公司名称
     * @param enterpriseRuleId 商户规则ID
     * @param pageNum
     * @param pageSize
     * @return  java.util.List<com.gic.enterprise.dto.rule.RuleEnterpriseDTO> 
     */
    ServiceResponse<Page<RuleEnterpriseDTO>> listEnterpriseRule(String search, Integer enterpriseRuleId,
            Integer pageNum, Integer pageSize);
}
