package com.gic.enterprise.utils;

import com.gic.commons.util.MD5Utils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanWrapper;
import org.springframework.beans.BeanWrapperImpl;

import java.beans.PropertyDescriptor;
import java.util.Map;
import java.util.TreeMap;

/**
 *
 * @Description:
 * @author zhiwj
 * @date 2019/8/30 17:42
 */
public class SignUtils {

    public static String getSign(Object source) {
        final BeanWrapper src = new BeanWrapperImpl(source);
        PropertyDescriptor[] pds = src.getPropertyDescriptors();
        TreeMap<String, Object> propertys = new TreeMap<>();
        for (PropertyDescriptor pd : pds) {
            String name = pd.getName();
            Object propertyValue = src.getPropertyValue(name);
            if (propertyValue != null && !"sign".equals(name) && !"class".equals(name) && !"payType".equals(name)) {
                propertys.put(name, propertyValue);
            }
        }
        StringBuilder sb = new StringBuilder();
        for (Map.Entry<String, Object> entry : propertys.entrySet()) {
            sb.append(entry.getKey()).append("=").append(entry.getValue()).append("&");
        }
        if (sb.length() > 0) {
            sb.deleteCharAt(sb.length() - 1);
        }

        return MD5Utils.ToMD5(sb.toString());
    }

    public static boolean validSign(Object source, String sign) {
        return StringUtils.equals(SignUtils.getSign(source), sign);
    }

}
