package com.gic.enterprise.service;

import com.gic.enterprise.dto.BillingEnterpriseSmsPackageDTO;
import com.gic.enterprise.entity.TabBillingEnterpriseSmsPackage;

import java.util.List;
/**
 * 我的套餐包
 * @ClassName: BillingEnterpriseSmsPackageService 
 * @Description:  
 * @author guojuxing 
 * @date 2019/8/20 2:25 PM 
 */
public interface BillingEnterpriseSmsPackageService {

    /**
     * 短信套餐包列表查询
     * @Title: listSmsPackage 
     * @Description:
      * @author guojuxing
     * @param enterpriseId 
     * @return  java.util.List<com.gic.enterprise.dto.BillingEnterpriseSmsPackageDTO> 
      */
    List<BillingEnterpriseSmsPackageDTO> listSmsPackage(Integer enterpriseId);

    TabBillingEnterpriseSmsPackage getSmsPackageDetail(Integer id);

    void saveEnterpriseSmsPackage(TabBillingEnterpriseSmsPackage smsPackage);

    /**
     * 更新信息
     * @Title: update 
     * @Description:
      * @author guojuxing
     * @param dto 
     * @return  void 
      */
    void update(BillingEnterpriseSmsPackageDTO dto);

    Integer deduct(Integer enterpriseId);

    /**
     * 查询该商户套餐包里全部拥有的可用短信条数
     */
    Integer getTotalSmsInPackageByEnterpriseId(Integer enterpriseId);
}
