package com.gic.enterprise.service;

import com.gic.enterprise.dto.HomeStatisticsDTO;
import com.gic.enterprise.dto.SmsRecordDTO;
import com.gic.enterprise.entity.TabBillingSmsRecord;
import com.gic.enterprise.qo.HomeStatisticsQO;
import com.gic.enterprise.qo.RecordQO;
import com.github.pagehelper.Page;

import java.util.List;
/**
 * 短信消费明细
 * @ClassName: BillingSmsRecordService 
 * @Description:    
 * @author guojuxing   
 * @date 2019/8/19 3:35 PM  
 */
public interface BillingSmsRecordService {

    /**
     * 趋势分析图
     * @Title: listHomeStatistics 
     * @Description:
      * @author guojuxing
     * @param params 
     * @return  java.util.List<com.gic.enterprise.dto.HomeStatisticsDTO> 
      */
    List<HomeStatisticsDTO> listHomeStatistics(HomeStatisticsQO params);

    /**
     * 获取本月或者上月消费金额
     * @Title: listFee 
     * @Description:
      * @author guojuxing
     * @param enterpriseId
     * @param dateType 
     * @return  double 
      */
    double getFee(Integer enterpriseId, Integer dateType);

    Page<TabBillingSmsRecord> listSmsPackageRecord(String search, String startDate, String endDate, Integer smsPackageId);

    Page<TabBillingSmsRecord> listSmsRecord(RecordQO recordQO);

    Integer countSmsRecord(RecordQO recordQO);

    Double getTotalFee(Integer enterpriseId, String startTime, String endTime);

    Integer saveSmsRecord(SmsRecordDTO smsRecordDTO);

    void updateCacheStatus(Integer smsRecordId);

    void updateDatabaseStatus(Integer smsRecordId);
}
