package com.gic.enterprise.service.impl;

import com.gic.commons.util.EntityUtil;
import com.gic.enterprise.dao.mapper.TabBillingEnterpriseSmsPackageMapper;
import com.gic.enterprise.dto.BillingEnterpriseSmsPackageDTO;
import com.gic.enterprise.entity.TabBillingEnterpriseSmsPackage;
import com.gic.enterprise.service.BillingEnterpriseSmsPackageService;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Service("billingEnterpriseSmsPackageService")
public class BillingEnterpriseSmsPackageServiceImpl implements BillingEnterpriseSmsPackageService {
    @Autowired
    private TabBillingEnterpriseSmsPackageMapper tabBillingEnterpriseSmsPackageMapper;

    @Override
    public List<BillingEnterpriseSmsPackageDTO> listSmsPackage(Integer enterpriseId) {
        List<TabBillingEnterpriseSmsPackage> list = tabBillingEnterpriseSmsPackageMapper.listSmsPackage(enterpriseId);
        if (CollectionUtils.isNotEmpty(list)) {
            return EntityUtil.changeEntityListNew(BillingEnterpriseSmsPackageDTO.class, list);
        }
        return new ArrayList<>();
    }

    @Override
    public TabBillingEnterpriseSmsPackage getSmsPackageDetail(Integer id) {
        return this.tabBillingEnterpriseSmsPackageMapper.selectByPrimaryKey(id);
    }

    @Override
    public void saveEnterpriseSmsPackage(TabBillingEnterpriseSmsPackage smsPackage) {
        this.tabBillingEnterpriseSmsPackageMapper.insert(smsPackage);
    }

    @Override
    public void update(BillingEnterpriseSmsPackageDTO dto) {
        dto.setUpdateTime(new Date());
        tabBillingEnterpriseSmsPackageMapper
                .updateByPrimaryKeySelective(EntityUtil.changeEntityNew(TabBillingEnterpriseSmsPackage.class, dto));
    }

    @Override
    public Integer deduct(Integer enterpriseId) {
        TabBillingEnterpriseSmsPackage billingEnterpriseSmsPackage = tabBillingEnterpriseSmsPackageMapper.getEarliest(enterpriseId);
        Integer line = tabBillingEnterpriseSmsPackageMapper.deduct(billingEnterpriseSmsPackage.getEnterpriseSmsPackageId());
        if (line == 0) {
            // 重新确认下是否是没有余量了
            TabBillingEnterpriseSmsPackage smsPackage = tabBillingEnterpriseSmsPackageMapper.selectByPrimaryKey(billingEnterpriseSmsPackage.getEnterpriseSmsPackageId());
            if (smsPackage.getRemainAccount() == 0) {
                smsPackage.setStatus(3);
                tabBillingEnterpriseSmsPackageMapper.updateByPrimaryKeySelective(smsPackage);
            }
            deduct(enterpriseId);
        }
        return billingEnterpriseSmsPackage.getEnterpriseSmsPackageId();
    }

    @Override
    public Integer getTotalSmsInPackageByEnterpriseId(Integer enterpriseId) {
        return tabBillingEnterpriseSmsPackageMapper.getTotalSmsInPackageByEnterpriseId(enterpriseId);
    }
}
