package com.gic.enterprise.service.impl;

import com.gic.commons.util.EntityUtil;
import com.gic.enterprise.dao.mapper.TabBillingInternationalSmsRecordMapper;
import com.gic.enterprise.dto.HomeStatisticsDTO;
import com.gic.enterprise.dto.InternationalSmsRecordDTO;
import com.gic.enterprise.entity.TabBillingInternationalSmsRecord;
import com.gic.enterprise.qo.HomeStatisticsQO;
import com.gic.enterprise.qo.RecordQO;
import com.gic.enterprise.service.BillingInternationalSmsRecordService;
import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @Description:
 * @author zhiwj
 * @date 2019-11-01 16:28
 */
@Service
public class BillingInternationalSmsRecordServiceImpl implements BillingInternationalSmsRecordService {

    @Autowired
    private TabBillingInternationalSmsRecordMapper tabBillingInternationalSmsRecordMapper;

    @Override
    public List<HomeStatisticsDTO> listHomeStatistics(HomeStatisticsQO params) {
        List<HomeStatisticsDTO> list = tabBillingInternationalSmsRecordMapper.listHomeStatistics(params);
        if (CollectionUtils.isNotEmpty(list)) {
            return list;
        }
        return new ArrayList<>();
    }

    @Override
    public double getFee(Integer enterpriseId, Integer dateType) {
        return tabBillingInternationalSmsRecordMapper.getFee(enterpriseId, dateType);
    }

    @Override
    public Page<TabBillingInternationalSmsRecord> listInternationalSmsRecord(RecordQO recordQO) {
        PageHelper.startPage(recordQO.getCurrentPage(), recordQO.getPageSize());
        return tabBillingInternationalSmsRecordMapper.listInternationalSmsRecord(recordQO);
    }

    @Override
    public Double getTotalFee(Integer enterpriseId, String startTime, String endTime) {
        return tabBillingInternationalSmsRecordMapper.getTotalFee(enterpriseId, startTime, endTime);
    }

    @Override
    public Integer save(InternationalSmsRecordDTO internationalSmsRecordDTO) {
        TabBillingInternationalSmsRecord billingInternationalSmsRecord = EntityUtil.changeEntityByJSON(TabBillingInternationalSmsRecord.class, internationalSmsRecordDTO);
        return this.tabBillingInternationalSmsRecordMapper.insertSelective(billingInternationalSmsRecord);
    }

    @Override
    public Integer countInternationalSmsRecord(RecordQO recordQO) {
        return tabBillingInternationalSmsRecordMapper.countInternationalSmsRecord(recordQO);
    }
}
