package com.gic.enterprise.service.impl;

import com.gic.commons.util.EntityUtil;
import com.gic.commons.util.GlobalInfo;
import com.gic.enterprise.dao.mapper.TabBillingVoiceCodeRecordMapper;
import com.gic.enterprise.dto.HomeStatisticsDTO;
import com.gic.enterprise.dto.VoiceCodeRecordDTO;
import com.gic.enterprise.entity.TabBillingVoiceCodeRecord;
import com.gic.enterprise.qo.HomeStatisticsQO;
import com.gic.enterprise.qo.RecordQO;
import com.gic.enterprise.service.BillingVoiceCodeRecordService;
import com.gic.store.utils.CreateSerialNumberUtils;
import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Service("billingVoiceCodeRecordService")
public class BillingVoiceCodeRecordServiceImpl implements BillingVoiceCodeRecordService{
    @Autowired
    private TabBillingVoiceCodeRecordMapper tabBillingVoiceCodeRecordMapper;
    @Override
    public List<HomeStatisticsDTO> listHomeStatistics(HomeStatisticsQO params) {
        List<HomeStatisticsDTO> list = tabBillingVoiceCodeRecordMapper.listHomeStatistics(params);
        if (CollectionUtils.isNotEmpty(list)) {
            return list;
        }
        return new ArrayList<>();
    }

    @Override
    public double getFee(Integer enterpriseId, Integer dateType) {
        return tabBillingVoiceCodeRecordMapper.getFee(enterpriseId, dateType);
    }

    @Override
    public Page<TabBillingVoiceCodeRecord> listVoiceCodeRecord(RecordQO recordQO) {
        PageHelper.startPage(recordQO.getCurrentPage(), recordQO.getPageSize());
        return tabBillingVoiceCodeRecordMapper.listVoiceCodeRecord(recordQO);
    }

    @Override
    public Integer countVoiceCodeRecord(RecordQO recordQO) {
        return tabBillingVoiceCodeRecordMapper.countVoiceCodeRecord(recordQO);
    }

    @Override
    public Double getTotalFee(Integer enterpriseId, String startTime, String endTime) {
        return tabBillingVoiceCodeRecordMapper.getTotalFee(enterpriseId, startTime, endTime);
    }

    @Override
    public Integer save(VoiceCodeRecordDTO voiceCodeRecordDTO) {
        TabBillingVoiceCodeRecord billingVoiceCodeRecord = EntityUtil.changeEntityByJSON(TabBillingVoiceCodeRecord.class, voiceCodeRecordDTO);
        billingVoiceCodeRecord.setStatus(GlobalInfo.DATA_STATUS_NORMAL);
        billingVoiceCodeRecord.setCreateTime(new Date());
        billingVoiceCodeRecord.setPaySerialNumber(CreateSerialNumberUtils.createSerialNumber());
        return tabBillingVoiceCodeRecordMapper.insertSelective(billingVoiceCodeRecord);
    }
}