package com.gic.enterprise.web.controller;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.enterprise.dto.*;
import com.gic.enterprise.qo.RecordQO;
import com.gic.enterprise.service.BillingRecordApiService;
import com.gic.enterprise.service.DictApiService;
import com.gic.enterprise.utils.ResultControllerUtils;
import com.gic.enterprise.utils.UserDetailUtils;
import com.gic.enterprise.web.vo.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

/**
 *
 * @Description:
 * @author zhiwj
 * @date 2019/8/22 16:33
 */
@RestController
public class BillingRecordController {

    @Autowired
    private BillingRecordApiService billingRecordApiService;
    @Autowired
    private DictApiService dictApiService;

    @RequestMapping("/list-account-balance")
    public RestResponse listAccountBalanceRecord(RecordQO recordQO) {
        recordQO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        ServiceResponse<Page<AccountBalanceRecordDTO>> serviceResponse = billingRecordApiService.listAccountBalanceRecord(recordQO);
        if (serviceResponse.isSuccess()) {
            Page page = new Page(serviceResponse.getResult().getCurrentPage(), serviceResponse.getResult().getPageSize(), serviceResponse.getResult().getTotalPage(), serviceResponse.getResult().getTotalCount());
            List<AccountBalanceRecordVO> list = EntityUtil.changeEntityListByJSON(AccountBalanceRecordVO.class, serviceResponse.getResult().getResult());
            page.setResult(list);
            return RestResponse.success(page);
        } else {
            return RestResponse.failure(serviceResponse.getCode(), serviceResponse.getMessage());
        }
    }

    @RequestMapping("/list-double-calling")
    public RestResponse listDoubleCallingRecord(RecordQO recordQO) {
        recordQO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        ServiceResponse<Page<DoubleCallingRecordDTO>> serviceResponse = billingRecordApiService.listDoubleCallingRecord(recordQO);
        if (serviceResponse.isSuccess()) {
            Page page = new Page(serviceResponse.getResult().getCurrentPage(), serviceResponse.getResult().getPageSize(), serviceResponse.getResult().getTotalPage(), serviceResponse.getResult().getTotalCount());
            List<DoubleCallingRecordVO> list = EntityUtil.changeEntityListByJSON(DoubleCallingRecordVO.class, serviceResponse.getResult().getResult());
            page.setResult(list);
            return RestResponse.success(page);
        } else {
            return RestResponse.failure(serviceResponse.getCode(), serviceResponse.getMessage());
        }
    }

    @RequestMapping("/list-recording-storage")
    public RestResponse listRecordingStorageRecord(RecordQO recordQO) {
        recordQO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        ServiceResponse<Page<RecordingStorageRecordDTO>> serviceResponse = billingRecordApiService.listRecordingStorageRecord(recordQO);
        if (serviceResponse.isSuccess()) {
            Page page = new Page(serviceResponse.getResult().getCurrentPage(), serviceResponse.getResult().getPageSize(), serviceResponse.getResult().getTotalPage(), serviceResponse.getResult().getTotalCount());
            List<RecordingStorageRecordVO> list = EntityUtil.changeEntityListByJSON(RecordingStorageRecordVO.class, serviceResponse.getResult().getResult());
            page.setResult(list);
            return RestResponse.success(page);
        } else {
            return RestResponse.failure(serviceResponse.getCode(), serviceResponse.getMessage());
        }
    }

    @RequestMapping("/list-sms-package")
    public RestResponse listSmsPackageRecord(RecordQO recordQO) {
        recordQO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        ServiceResponse<Page<SmsPackageRecordDTO>> serviceResponse = billingRecordApiService.listSmsPackageRecord(recordQO);
        if (serviceResponse.isSuccess()) {
            Page page = new Page(serviceResponse.getResult().getCurrentPage(), serviceResponse.getResult().getPageSize(), serviceResponse.getResult().getTotalPage(), serviceResponse.getResult().getTotalCount());
            List<SmsPackageRecordVO> list = EntityUtil.changeEntityListByJSON(SmsPackageRecordVO.class, serviceResponse.getResult().getResult());
            page.setResult(list);
            return RestResponse.success(page);
        } else {
            return RestResponse.failure(serviceResponse.getCode(), serviceResponse.getMessage());
        }
    }

    @RequestMapping("/list-sms")
    public RestResponse listSmsRecord(RecordQO recordQO) {
        recordQO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        ServiceResponse<Page<SmsRecordDTO>> serviceResponse = billingRecordApiService.listSmsRecord(recordQO);
        if (serviceResponse.isSuccess()) {
            Page page = new Page(serviceResponse.getResult().getCurrentPage(), serviceResponse.getResult().getPageSize(), serviceResponse.getResult().getTotalPage(), serviceResponse.getResult().getTotalCount());
            List<SmsRecordVO> list = EntityUtil.changeEntityListByJSON(SmsRecordVO.class, serviceResponse.getResult().getResult());
            page.setResult(list);
            return RestResponse.success(page);
        } else {
            return RestResponse.failure(serviceResponse.getCode(), serviceResponse.getMessage());
        }
    }

    @RequestMapping("/list-international-sms")
    public RestResponse listInternationalSmsRecord(RecordQO recordQO) {
        recordQO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        ServiceResponse<Page<InternationalSmsRecordDTO>> serviceResponse = billingRecordApiService.listInternationalSmsRecord(recordQO);
        if (serviceResponse.isSuccess()) {
            Page page = new Page(serviceResponse.getResult().getCurrentPage(), serviceResponse.getResult().getPageSize(), serviceResponse.getResult().getTotalPage(), serviceResponse.getResult().getTotalCount());
            List<InternationalSmsRecordVO> list = EntityUtil.changeEntityListByJSON(InternationalSmsRecordVO.class, serviceResponse.getResult().getResult());
            page.setResult(list);
            return RestResponse.success(page);
        } else {
            return RestResponse.failure(serviceResponse.getCode(), serviceResponse.getMessage());
        }
    }

    @RequestMapping("/list-voice-code")
    public RestResponse listVoiceCodeRecord(RecordQO recordQO) {
        recordQO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        ServiceResponse<Page<VoiceCodeRecordDTO>> serviceResponse = billingRecordApiService.listVoiceCodeRecord(recordQO);
        if (serviceResponse.isSuccess()) {
            Page page = new Page(serviceResponse.getResult().getCurrentPage(), serviceResponse.getResult().getPageSize(), serviceResponse.getResult().getTotalPage(), serviceResponse.getResult().getTotalCount());
            List<VoiceCodeRecordVO> list = EntityUtil.changeEntityListByJSON(VoiceCodeRecordVO.class, serviceResponse.getResult().getResult());
            page.setResult(list);
            return RestResponse.success(page);
        } else {
            return RestResponse.failure(serviceResponse.getCode(), serviceResponse.getMessage());
        }
    }

    @RequestMapping("/list-fee")
    public RestResponse listFee(String startTime, String endTime) {
        ServiceResponse<List<Map<String, Object>>> serviceResponse = billingRecordApiService.listFee(UserDetailUtils.getUserDetail().getEnterpriseId(), startTime, endTime);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/list-sms-app-type")
    public RestResponse listSmsAppType() {
        ServiceResponse<List<DictDTO>> serviceResponse = dictApiService.listSmsAppType();
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    

}
