package com.gic.enterprise.web.controller;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.enterprise.dto.LinkDTO;
import com.gic.enterprise.service.LinkApiService;
import com.gic.enterprise.utils.ResultControllerUtils;
import com.gic.enterprise.utils.UserDetailUtils;
import com.gic.member.config.api.dto.AppletCardRelationDTO;
import com.gic.member.config.api.dto.AppletsConfigSimpleOutputDTO;
import com.gic.member.config.api.service.AppletsConfigApiService;
import com.gic.member.config.api.service.ServiceConfigApiService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Collections;
import java.util.List;

/**
 *
 * @Description:
 * @author zhiwj
 * @date 2019-11-26 16:29
 */
@RestController
public class LinkController {

    @Autowired
    private LinkApiService linkApiService;
    @Autowired
    private AppletsConfigApiService appletsConfigApiService;
    @Autowired
    private ServiceConfigApiService serviceConfigApiService;

    @RequestMapping("/list-link-data")
    public RestResponse listLinkData(Integer parentId) {
        ServiceResponse<List<LinkDTO>> serviceResponse = linkApiService.listByGic(UserDetailUtils.getUserDetail().getEnterpriseId(), parentId);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/tree-link-data")
    public RestResponse treeLinkData(Integer objectType) {
        ServiceResponse<List<LinkDTO>> serviceResponse = linkApiService.treeByGic(UserDetailUtils.getUserDetail().getEnterpriseId(), objectType);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/list-applet-card")
    public RestResponse listAppletConfigByCardConfigIds(Long cardConfigId) {
        ServiceResponse<List<AppletsConfigSimpleOutputDTO>> serviceResponse = this.appletsConfigApiService.listAppletConfigByCardConfigIds(Collections.singletonList(cardConfigId), UserDetailUtils.getUserDetail().getEnterpriseId());
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/list-applet-service")
    public RestResponse queryCardConfigBindServiceConfig(Long serviceConfigId) {
        ServiceResponse<List<AppletCardRelationDTO>> serviceResponse = this.serviceConfigApiService.queryCardConfigBindServiceConfig(serviceConfigId, UserDetailUtils.getUserDetail().getEnterpriseId());
        return ResultControllerUtils.commonResult(serviceResponse);
    }

}
